\documentclass{article}
\usepackage[english]{babel}
\usepackage[utf8]{inputenc}

%\pagestyle{headings}
\usepackage{tikz}
\usetikzlibrary{positioning}
\usetikzlibrary{fit}
\begin{document}

\section*{LiteBusMonitor}
The LiteBusMonitor component is a LiteX component for the purpose of monitoring and recording bus transactions of a SoC. (WIP: To be used in combination with the security/rule-enforcer type component to act on suspicious bus transactions). 

\bigskip

\makebox[\textwidth][c]{
\begin{tikzpicture}[
componentNode/.style={rectangle, draw=green!60, fill=green!5, very thick, minimum size=7mm},
litexNode/.style={rectangle, draw=blue!60, fill=blue!5, very thick, minimum size=7mm},
busNode/.style={rectangle, draw=yellow!60, fill=yellow!5, very thick, minimum size=7mm, minimum width=10cm},
cpuNode/.style={rectangle, draw=red!60, fill=red!5, very thick, minimum size=7mm},
memoryNode/.style={rectangle, draw=cyan!60, fill=cyan!15, very thick, minimum size=7mm, minimum height=3cm, minimum width = 3cm}
]

% \node[depth=3cm](soc){SoC}

%Nodes
\node[componentNode] (mc) at (0,0){Monitoring Component}; % at (soc.center)
\node[componentNode](bm) at (0,-2) {Bus Monitor};
\node[componentNode](sm) at (0,-4) {Signal Monitor};
%\node[litexNode](dma) at (0, 2) {DMA};

\node[busNode] (bn2) at (0,3) {Bus Master 2};
\node[busNode] (bn1) at (0,4) {Bus Master 1};
\node[busNode] (mcbm) at (0,2) {Monitor Component Bus Master};

\node[cpuNode] (cpu) at (-4, 0) {CPU};

\node[memoryNode] (mem) at (-8,|- bn2) {Memory};


%Lines
\draw[<->] (mc.south) -- (bm.north);
\draw[<->] (bm.south) -- (sm.north);
%\draw[->] (mc.north) -- (dma.south);


\draw[<->] (cpu.north west) -- (cpu.north west |- bn1.south);
\draw[<->] (cpu.north east) -- (cpu.north east |- bn2.south);
%\draw[<->] (dma.north) -- (mcbm.south);
\draw[<->] (cpu.east) -- (mc.west) node[midway, above] {CSRs};

\draw[->] (bn1.east) -- (5.5, |- bn1.center);
\draw[->] (bn2.east) -- (5.5, |- bn2.center);
\draw[->] (5.5, |- bn1.center) -- (5.5, |- mc.center) -- (mc.east);

\draw[<->] (bn1.west) -- (mem.east |- bn1.west);
\draw[<->] (bn2.west) -- (mem.east |- bn2.west);
\draw[<->] (mcbm.west) -- (mem.east |- mcbm.west);
\draw[<->] (mc.north) -- (mcbm.south);

\node[fit=(mc)(bm)(sm)(bn2)(bn1)(cpu)(mem)(mcbm), draw, very thick, draw=gray, inner sep=1cm] (soc) {};
\node[below right] at (soc.north west) {SoC}; 
\end{tikzpicture}
}

\section*{Signal Monitor}
The most basic component of the package is the \textit{SignalMonitor} module. It takes a list of trigger signals or migen statements, a triggerMode that determines the type of trigger (rising, falling, changing, high, etc.) and a dictionary of signals to monitor with their names as keys. Internally the entries that get recorded are saved in a queue, accessible via the SignalMonitor's source attribute.

\bigskip

\makebox[\textwidth][c]{
\begin{tikzpicture}[componentNode/.style={rectangle, draw=green!60, fill=green!5, very thick, minimum size=2cm}]

\node[componentNode] (q) {FIFO};

\node[fit=(q), inner sep=3cm, draw, very thick, draw=gray] (signalmonitor) {};
\node[below right] at (signalmonitor.north west) {SignalMonitor};


\node[left= of signalmonitor, minimum height=2cm] (recordSignals) {};
\node[above= of recordSignals] (triggerSignals) {};

\draw[->, very thick] (recordSignals.east) -- (signalmonitor.west);
\draw[->, thick] (triggerSignals.east) -- (triggerSignals.east -| signalmonitor.west);
\draw[->, very thick] (signalmonitor.west) -- (q.west) node[midway, above] {Record Signals};
\draw[-, thick] (triggerSignals.east -| signalmonitor.west) -- (triggerSignals.east -| q.north) node[midway, above] {Trigger Signals};
\draw[->, thick] (triggerSignals.east -| q.north) -- (q.north);
\draw[->, very thick] (q.east) -- (signalmonitor.east);

\node[right= of signalmonitor] (fifoout) {};
\draw[->, very thick] (signalmonitor.east) -- (fifoout.west);
\end{tikzpicture}
}

\section*{Bus Monitor}
The bus monitor does not encapsulate any significant logic itself and instead abstracts the signal monitor. Instead of passing signals themselves and setting up the correct triggers, the bus monitor simply receives a list of LiteX's Bus Interfaces (masters) and depending on what should be recorded sets up a signal monitor for that purpose and reroutes it's output to the bus monitors own source output.

\section*{Monitoring Component}
This component is the user-interfacing one. It takes the master interfaces to monitor and passes them onto an internal bus monitor. The result of the monitors queue is then passed into a gearbox making 32-bit words from the arbitrary long queue entries. The data is then passed onto the DMA that writes it into memory, as soon as the CPU has assigned a free space that is large enough. The DMA only writes when an address was set. It can write as soon as the queue makes a value available. If the end of the memory was reached by the DMA it blocks until it's adress is reset, the queue is flushed, etc. (WIP: Control register for the monitoring component).

The component generates a C-Header file that contains infos about the bit length, ordering and names of the signals that were monitored. The firmware can use that header to decode the data again. The decoder python script can boot the firmware, record the serial output data and sort it into a csv, ready for ML, visualization, etc.

\bigskip

\makebox[\textwidth][c]{
\begin{tikzpicture}[componentNode/.style={rectangle, draw=green!60, fill=green!5, very thick, minimum size=2cm},
litexNode/.style={rectangle, draw=blue!60, fill=blue!5, very thick, minimum size=2cm}]

\node[componentNode] (queue) {BusMonitor (FIFO)};
\node[componentNode, right=of queue] (gb) {Gearbox};
\node[litexNode, right=of gb] (DMA) {DMA};

\node[fit=(queue)(gb)(DMA), inner sep=2cm, draw, very thick, draw=gray] (moncomp) {};
\node[below right] at (moncomp.north west) {DMAMonitoringComponent};

\node[left=of moncomp] (in) {};
\draw[->, thick] (in.east) -- (moncomp.west);
\draw[->, thick] (moncomp.west) -- (queue.west) node[midway, above] {Interfaces};

\draw[->, very thick] (queue.east) -- (gb.west) node[midway, above] {~84 bit};
\draw[->, thick] (gb.east) -- (DMA.west) node[midway, above] {32 bit};
\node[right=of moncomp] (out) {};
\draw[->, thick] (DMA.east) -- (moncomp.east) node[midway, above] {Data};
\draw[->, thick] (moncomp.east) -- (out.west);

\end{tikzpicture}
}

\end{document}